javax.websocket.server

## Class ServerEndpointConfig.Configurator

- java.lang.Object
- - javax.websocket.server.ServerEndpointConfig.Configurator

- Enclosing interface:
    ServerEndpointConfig

      public static class ServerEndpointConfig.Configurator
      extends Object

  The ServerEndpointConfig.Configurator class may be extended by developers who want to provide custom configuration algorithms, such as intercepting the opening handshake, or providing arbitrary methods and algorithms that can be accessed from each endpoint instance configured with this configurator. The implementation must provide a platform default configurator loading using the service loader.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ServerEndpointConfig.Configurator()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `checkOrigin(String originHeaderValue)` Check the value of the Origin header (See Origin Header) the client passed during the opening handshake.
    `<T> T` | `getEndpointInstance(Class<T> endpointClass)` This method is called by the container each time a new client connects to the logical endpoint this configurator configures.
    `List<Extension>` | `getNegotiatedExtensions(List<Extension> installed, List<Extension> requested)` Return the ordered list of extensions that t server endpoint will support given the requested extension list passed in, the empty list if none.
    `String` | `getNegotiatedSubprotocol(List<String> supported, List<String> requested)` Return the subprotocol the server endpoint has chosen from the requested list supplied by a client who wishes to connect, or none if there wasn't one this server endpoint liked.
    `void` | `modifyHandshake(ServerEndpointConfig sec, HandshakeRequest request, HandshakeResponse response)` Called by the container after it has formulated a handshake response resulting from a well-formed handshake request.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ServerEndpointConfig.Configurator

          public ServerEndpointConfig.Configurator()

  - ### Method Detail

    - #### getNegotiatedSubprotocol

          public String getNegotiatedSubprotocol(List<String> supported,
                                        List<String> requested)

      Return the subprotocol the server endpoint has chosen from the requested list supplied by a client who wishes to connect, or none if there wasn't one this server endpoint liked. See Sending the Server's Opening Handshake. Subclasses may provide custom algorithms based on other factors.

      The default platform implementation of this method returns the first subprotocol in the list sent by the client that the server supports, or the empty string if there isn't one.

      Parameters:
        `requested` - the requested subprotocols from the client endpoint
        `supported` - the subprotocols supported by the server endpoint
      Returns:
        the negotiated subprotocol or the empty string if there isn't one.

    - #### getNegotiatedExtensions

          public List<Extension> getNegotiatedExtensions(List<Extension> installed,
                                                List<Extension> requested)

      Return the ordered list of extensions that t server endpoint will support given the requested extension list passed in, the empty list if none. See Negotiating Extensions

      The default platform implementation of this method returns a list containing all of the requested extensions passed to this method that it supports, using the order in the requested extensions, the empty list if none.

      Parameters:
        `installed` - the installed extensions on the implementation.
        `requested` - the requested extensions, in the order they were requested by the client
      Returns:
        the list of extensions negotiated, the empty list if none.

    - #### checkOrigin

          public boolean checkOrigin(String originHeaderValue)

      Check the value of the Origin header (See Origin Header) the client passed during the opening handshake.

      The platform default implementation of this method makes a check of the validity of the Origin header sent along with the opening handshake following the recommendation at: Sending the Server's Opening Handshake.

      Parameters:
        `originHeaderValue` - the value of the origin header passed by the client.
      Returns:
        whether the check passed or not

    - #### modifyHandshake

          public void modifyHandshake(ServerEndpointConfig sec,
                             HandshakeRequest request,
                             HandshakeResponse response)

      Called by the container after it has formulated a handshake response resulting from a well-formed handshake request. The container has already checked that this configuration has a matching URI, determined the validity of the origin using the checkOrigin method, and filled out the negotiated subprotocols and extensions based on this configuration. Custom configurations may override this method in order to inspect the request parameters and modify the handshake response that the server has formulated. and the URI checking also.

      If the developer does not override this method, no further modification of the request and response are made by the implementation.

      Parameters:
        `sec` - the configuration object involved in the handshake
        `request` - the opening handshake request.
        `response` - the proposed opening handshake response

    - #### getEndpointInstance

          public <T> T getEndpointInstance(Class<T> endpointClass)
                                throws InstantiationException

      This method is called by the container each time a new client connects to the logical endpoint this configurator configures. Developers may override this method to control instantiation of endpoint instances in order to customize the initialization of the endpoint instance, or manage them in some other way. If the developer overrides this method, services like dependency injection that are otherwise supported, for example, when the implementation is part of the Java EE platform may not be available. The platform default implementation of this method returns a new endpoint instance per call, thereby ensuring that there is one endpoint instance per client, the default deployment cardinality.
      Type Parameters:
        `T` - the type of the endpoint
      Parameters:
        `endpointClass` - the class of the endpoint
      Returns:
        an instance of the endpoint that will handle all interactions from a new client.
      Throws:
        `InstantiationException` - if there was an error producing the endpoint instance.

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.